<template>
    <NuxtLayout name="default">
        <div class="catalog-page">

            <!-- sidebar navigation teleported to template -->
            <SidebarNav :nav="navItems" :title="'Sharing'" />

            <Datatable :data="data" @open-edit-modal="handleOpenEditModal">
                <template v-slot:default>
                    <button class="button-secondary orange" @click="showCreateDataProductModal = true">
                        Create a Data product
                    </button>
                    <div class="filters-top-totals"><b>1211 Data Products</b> available</div>
                </template>
            </Datatable>

        </div>
 
        <ClientOnly>
            <Teleport to="#modals-container">
                <ModalsCreateDataProduct v-if="showCreateDataProductModal" :id="selectedRow ? selectedRow : ''" @toggle="close" :isEditMode="isEditMode" />
            </Teleport>
        </ClientOnly>

        <div class="offset-xl-1 col-xl-10">
            <BannersBannerCta :banners="BannerCta" />
        </div>

    </NuxtLayout>
</template>
<script setup lang="ts">
import type DataTableI from '~/interfaces/datatable';
import type NavItemI from '~/interfaces/navItem';
import slide1 from '@/assets/images/slide1.png';
import type sliderItemI from '~/interfaces/sliderItem';

const selectedRow = ref(null);
const isEditMode = ref(false);

useHead({
    title: 'Catalog - DATAMITE'
});

const showCreateDataProductModal = ref(false);

const handleOpenEditModal = (row: any) => {
    selectedRow.value = row?.id; // Pass the selected row data to the modal
    isEditMode.value = true;
    showCreateDataProductModal.value = true; // Open the Edit Dataset modal
};


const close = () => {
    showCreateDataProductModal.value = false;
    isEditMode.value = false;
};

// make the function close available to emit in other components
defineExpose({ close });

const data = ref<DataTableI>({
    options: {
        tableName: 'catalog-table',
        detailsPath: '/catalog/',
        allowCheckRow: true,
        favourites: true,
        previewComponent: 'CatalogDetails',
    },
    columns: [
        {
            id: 1,
            name: 'name',
            label: 'Name',
            filterType: 'text',
            width: '300px',
            combineColumn: 'type',
            renderComponent: 'TableColumnsName'
        },
        {
            id: 2,
            name: 'platform',
            label: 'Platform',
            filterType: 'select',
            width: '100px',
            searchable: true,
            searchableType: 'list'
        },
        {
            id: 3,
            name: 'domain',
            label: 'Domain',
            filterType: 'select',
            width: '140px',
            searchable: true,
            searchableType: 'list'
        },
        {
            id: 4,
            name: 'quality',
            label: 'Quality',
            width: '100px',
            renderComponent: 'TableColumnsQuality'
        },
        {
            id: 5,
            name: 'owner',
            label: 'Owner',
            filterType: 'select',
            width: '200px',
            renderComponent: 'UserProfile'
        },
        {
            id: 6,
            name: 'actions',
            label: 'Actions',
            width: '80px',
            hideLabel: true
        }
    ],
    rows: [
        {
            id: 1,
            name: 'Forecast Previsions',
            type: 'Data product',
            description: 'This dataset contains the forecast previsions for the next 5 years.',
            created_at: 'Nov 19 2024, 18:01:46',
            edited_at: 'Nov 19 2024, 18:01:46',
            platform: 'BigQuery',
            domain: 'Computer Science Finance',
            quality: 97,
            owner: 1,
            ownerName: 'John Doe',
            terms: [
                {
                    id: 1,
                    name: 'Regression Analysis',
                },
                {
                    id: 1,
                    name: 'Previsions',
                },
                {
                    id: 1,
                    name: 'Healthcare',
                }
            ],
            actions: ''
        },
        {
            id: 2,
            name: 'Forecast Previsions',
            type: 'Data product',
            description: 'This dataset contains the forecast previsions for the next 5 years.',
            created_at: 'Nov 19 2024, 18:01:46',
            edited_at: 'Nov 19 2024, 18:01:46',
            platform: 'BigQuery',
            domain: 'Computer Science Finance',
            quality: 97,
            owner: 1,
            ownerName: 'John Doe',
            terms: '',
            actions: ''
        },
        {
            id: 3,
            name: 'Forecast Previsions',
            type: 'Data product',
            description: 'This dataset contains the forecast previsions for the next 5 years.',
            created_at: 'Nov 19 2024, 18:01:46',
            edited_at: 'Nov 19 2024, 18:01:46',
            platform: 'BigQuery',
            domain: 'Computer Science Finance',
            quality: 97,
            owner: 1,
            ownerName: 'John Doe',
            terms: '',
            actions: ''
        },
        {
            id: 4,
            name: 'Forecast Previsions',
            type: 'Data product',
            description: 'This dataset contains the forecast previsions for the next 5 years.',
            created_at: 'Nov 19 2024, 18:01:46',
            edited_at: 'Nov 19 2024, 18:01:46',
            platform: 'BigQuery',
            domain: 'Computer Science Finance',
            quality: 97,
            owner: 1,
            ownerName: 'John Doe',
            terms: '',
            actions: ''
        },
        {
            name: 'Forecast Previsions',
            type: 'Data product',
            description: 'This dataset contains the forecast previsions for the next 5 years.',
            created_at: 'Nov 19 2024, 18:01:46',
            edited_at: 'Nov 19 2024, 18:01:46',
            platform: 'BigQuery',
            domain: 'Computer Science Finance',
            quality: 97,
            owner: 1,
            ownerName: 'John Doe',
            terms: '',
            actions: ''
        }
    ]
});

const viewDefault = () => {
    console.log('show default home page');
}

const dummyClick = () => {
    console.log('dummyClick');
}

const navItems = ref<NavItemI[]>([
    {
        label: 'All',
        icon: 'list',
        action: viewDefault
    },
    {
        label: 'Combine Datasets',
        icon: 'chrome',
        action: dummyClick
    },
    {
        label: 'Recently Viewed',
        icon: 'clock',
        action: dummyClick
    },
    {
        label: 'Highlighted',
        icon: 'favourite',
        action: dummyClick
    },
    {
        label: 'Your Catalog',
        icon: 'loading',
        action: dummyClick
    }
]);


const BannerCta = ref<sliderItemI[]>([
    {
        id: 1,
        title: 'Have a question or doubts?',
        text: 'Check our FAQs and Documentation',
        button_text: 'Faqs and Documentation',
        button_link: 'https://www.google.com',
        media_type: 1,
        media_url: slide1,
        template: 1,
    }
])

</script>